Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## ij
Class ImageJ

    java.lang.Object
      java.awt.Component
          java.awt.Container
              java.awt.Window
                  java.awt.Frame
                      ij.ImageJ

All Implemented Interfaces:
  javax.accessibility.Accessible, java.awt.event.ActionListener, java.util.EventListener, java.awt.image.ImageObserver, java.awt.event.ItemListener, java.awt.event.KeyListener, java.awt.MenuContainer, java.awt.event.MouseListener, java.lang.Runnable, java.io.Serializable, java.awt.event.WindowListener

public class ImageJ
extends java.awt.Frame
implements java.awt.event.ActionListener, java.awt.event.MouseListener, java.awt.event.KeyListener, java.awt.event.WindowListener, java.awt.event.ItemListener, java.lang.Runnable

This frame is the main ImageJ class.

ImageJ is a work of the United States Government. It is in the public domain and open source. There is no copyright. You are free to do anything you want with this source but I like to get credit for my work and I would like you to offer your changes to me so I can possibly add them to the "official" version.

    The following command line options are recognized by ImageJ:

      "file-name"
         Opens a file
         Example 1: blobs.tif
         Example 2: /Users/wayne/images/blobs.tif
         Example3: e81*.tif

      -ijpath path
         Specified the path to the directory containing the plugins directory
         Example: -ijpath /Applications/ImageJ

      -port
         Specifies the port ImageJ uses to determine if another instance is running
         Example 1: -port1
         Example 2: -port2

      -macro path [arg]
         Runs a macro, passing it an optional argument
         Example 1: -macro analyze.ijm
         Example 2: -macro analyze /Users/wayne/images/stack1

      -batch path [arg]
        Runs a macro in batch (no GUI) mode, passing it an optional argument.
        ImageJ exits when the macro finishes.

      -eval "macro code"
         Evaluates macro code
         Example 1: -eval "print('Hello, world');"
         Example 2: -eval "return getVersion();"

      -run command
         Runs an ImageJ menu command
         Example: -run "About ImageJ..."

Author:
  Wayne Rasband (wsr@nih.gov)
See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class java.awt.Frame
`java.awt.Frame.AccessibleAWTFrame`

Nested classes inherited from class java.awt.Window
`java.awt.Window.AccessibleAWTWindow`

Nested classes inherited from class java.awt.Container
`java.awt.Container.AccessibleAWTContainer`

Nested classes inherited from class java.awt.Component
`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

Field Summary
`static java.awt.Color` | `backgroundColor`
`static int` | `DEFAULT_PORT` Address of socket where Image accepts commands
`static int` | `EMBEDDED`
`static java.awt.Font` | `SansSerif12` SansSerif, 12-point, plain font.
`static int` | `STANDALONE`
`static java.lang.String` | `VERSION` Plugins should call IJ.getVersion() to get the version string.

Fields inherited from class java.awt.Frame
`CROSSHAIR_CURSOR, DEFAULT_CURSOR, E_RESIZE_CURSOR, HAND_CURSOR, ICONIFIED, MAXIMIZED_BOTH, MAXIMIZED_HORIZ, MAXIMIZED_VERT, MOVE_CURSOR, N_RESIZE_CURSOR, NE_RESIZE_CURSOR, NORMAL, NW_RESIZE_CURSOR, S_RESIZE_CURSOR, SE_RESIZE_CURSOR, SW_RESIZE_CURSOR, TEXT_CURSOR, W_RESIZE_CURSOR, WAIT_CURSOR`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`ImageJ()` Creates a new ImageJ frame that runs as an application.
`ImageJ(java.applet.Applet applet)` Creates a new ImageJ frame that runs as an applet.
`ImageJ(java.applet.Applet applet, int mode)` If 'applet' is not null, creates a new ImageJ frame that runs as an applet.

Method Summary
`void` | `actionPerformed(java.awt.event.ActionEvent e)` Handle menu events.
`void` | `exitWhenQuitting(boolean ewq)` ImageJ calls System.exit() when qutting when 'exitWhenQuitting' is true.
`static java.lang.String[]` | `getArgs()` Returns the command line arguments passed to ImageJ.
`static int` | `getPort()` Returns the port that ImageJ checks on startup to see if another instance is running.
`java.awt.Point` | `getPreferredLocation()`
`ProgressBar` | `getProgressBar()`
`void` | `itemStateChanged(java.awt.event.ItemEvent e)` Handles CheckboxMenuItem state changes.
`void` | `keyPressed(java.awt.event.KeyEvent e)`
`void` | `keyReleased(java.awt.event.KeyEvent e)`
`void` | `keyTyped(java.awt.event.KeyEvent e)`
`static void` | `main(java.lang.String[] args)`
`static java.lang.String` | `modifiers(int flags)` Return the current list of modifier keys.
`void` | `mouseClicked(java.awt.event.MouseEvent e)`
`void` | `mouseEntered(java.awt.event.MouseEvent e)`
`void` | `mouseExited(java.awt.event.MouseEvent e)`
`void` | `mousePressed(java.awt.event.MouseEvent e)`
`void` | `mouseReleased(java.awt.event.MouseEvent e)`
`void` | `quit()` Called by ImageJ when the user selects Quit.
`boolean` | `quitting()` Returns true if ImageJ is exiting.
`void` | `register(java.lang.Class c)` Adds the specified class to a Vector to keep it from being garbage collected, causing static fields to be reset.
`void` | `run()` Quit using a separate thread, hopefully avoiding thread deadlocks.
`void` | `runFilterPlugIn(java.lang.Object theFilter, java.lang.String cmd, java.lang.String arg)`
`java.lang.Object` | `runUserPlugIn(java.lang.String commandName, java.lang.String className, java.lang.String arg, boolean createNewLoader)`
`void` | `savePreferences(java.util.Properties prefs)` Called once when ImageJ quits.
`void` | `windowActivated(java.awt.event.WindowEvent e)`
`void` | `windowClosed(java.awt.event.WindowEvent e)`
`void` | `windowClosing(java.awt.event.WindowEvent e)`
`void` | `windowDeactivated(java.awt.event.WindowEvent e)`
`void` | `windowDeiconified(java.awt.event.WindowEvent e)`
`void` | `windowIconified(java.awt.event.WindowEvent e)`
`void` | `windowOpened(java.awt.event.WindowEvent e)`

Methods inherited from class java.awt.Frame
`addNotify, finalize, getAccessibleContext, getCursorType, getExtendedState, getFrames, getIconImage, getMaximizedBounds, getMenuBar, getState, getTitle, isResizable, isUndecorated, paramString, remove, removeNotify, setCursor, setExtendedState, setIconImage, setMaximizedBounds, setMenuBar, setResizable, setState, setTitle, setUndecorated`

Methods inherited from class java.awt.Window
`addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getGraphicsConfiguration, getInputContext, getListeners, getLocale, getMostRecentFocusOwner, getOwnedWindows, getOwner, getToolkit, getWarningString, getWindowFocusListeners, getWindowListeners, getWindowStateListeners, hide, isActive, isFocusableWindow, isFocusCycleRoot, isFocused, isShowing, pack, postEvent, processEvent, processWindowEvent, processWindowFocusEvent, processWindowStateEvent, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, setCursor, setFocusableWindowState, setFocusCycleRoot, setLocationRelativeTo, show, toBack, toFront`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paint, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, remove, removeAll, removeContainerListener, setFocusTraversalKeys, setFocusTraversalPolicy, setFont, setLayout, transferFocusBackward, transferFocusDownCycle, update, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isOpaque, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, setBackground, setBounds, setBounds, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, setVisible, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.awt.MenuContainer
`getFont, postEvent`

Field Detail

### VERSION

    public static final java.lang.String VERSION

  Plugins should call IJ.getVersion() to get the version string.

  See Also:
    Constant Field Values

### backgroundColor

    public static java.awt.Color backgroundColor

### SansSerif12

    public static final java.awt.Font SansSerif12

  SansSerif, 12-point, plain font.

### DEFAULT_PORT

    public static final int DEFAULT_PORT

  Address of socket where Image accepts commands

  See Also:
    Constant Field Values

### STANDALONE

    public static final int STANDALONE

See Also:
  Constant Field Values

### EMBEDDED

    public static final int EMBEDDED

See Also:
  Constant Field Values

Constructor Detail

### ImageJ

    public ImageJ()

  Creates a new ImageJ frame that runs as an application.

### ImageJ

    public ImageJ(java.applet.Applet applet)

  Creates a new ImageJ frame that runs as an applet.

### ImageJ

    public ImageJ(java.applet.Applet applet,
                  int mode)

  If 'applet' is not null, creates a new ImageJ frame that runs as an applet. If 'mode' is ImageJ.EMBEDDED and 'applet is null, creates an embedded version of ImageJ which does not start the SocketListener.

Method Detail

### getPreferredLocation

    public java.awt.Point getPreferredLocation()

### getProgressBar

    public ProgressBar getProgressBar()

### runFilterPlugIn

    public void runFilterPlugIn(java.lang.Object theFilter,
                                java.lang.String cmd,
                                java.lang.String arg)

### runUserPlugIn

    public java.lang.Object runUserPlugIn(java.lang.String commandName,
                                          java.lang.String className,
                                          java.lang.String arg,
                                          boolean createNewLoader)

### modifiers

    public static java.lang.String modifiers(int flags)

  Return the current list of modifier keys.

### actionPerformed

    public void actionPerformed(java.awt.event.ActionEvent e)

  Handle menu events.

  Specified by:
    `actionPerformed` in interface `java.awt.event.ActionListener`

### itemStateChanged

    public void itemStateChanged(java.awt.event.ItemEvent e)

  Handles CheckboxMenuItem state changes.

  Specified by:
    `itemStateChanged` in interface `java.awt.event.ItemListener`

### mousePressed

    public void mousePressed(java.awt.event.MouseEvent e)

  Specified by:
    `mousePressed` in interface `java.awt.event.MouseListener`

### mouseReleased

    public void mouseReleased(java.awt.event.MouseEvent e)

  Specified by:
    `mouseReleased` in interface `java.awt.event.MouseListener`

### mouseExited

    public void mouseExited(java.awt.event.MouseEvent e)

  Specified by:
    `mouseExited` in interface `java.awt.event.MouseListener`

### mouseClicked

    public void mouseClicked(java.awt.event.MouseEvent e)

  Specified by:
    `mouseClicked` in interface `java.awt.event.MouseListener`

### mouseEntered

    public void mouseEntered(java.awt.event.MouseEvent e)

  Specified by:
    `mouseEntered` in interface `java.awt.event.MouseListener`

### keyPressed

    public void keyPressed(java.awt.event.KeyEvent e)

  Specified by:
    `keyPressed` in interface `java.awt.event.KeyListener`

### keyTyped

    public void keyTyped(java.awt.event.KeyEvent e)

  Specified by:
    `keyTyped` in interface `java.awt.event.KeyListener`

### keyReleased

    public void keyReleased(java.awt.event.KeyEvent e)

  Specified by:
    `keyReleased` in interface `java.awt.event.KeyListener`

### windowClosing

    public void windowClosing(java.awt.event.WindowEvent e)

  Specified by:
    `windowClosing` in interface `java.awt.event.WindowListener`

### windowActivated

    public void windowActivated(java.awt.event.WindowEvent e)

  Specified by:
    `windowActivated` in interface `java.awt.event.WindowListener`

### windowClosed

    public void windowClosed(java.awt.event.WindowEvent e)

  Specified by:
    `windowClosed` in interface `java.awt.event.WindowListener`

### windowDeactivated

    public void windowDeactivated(java.awt.event.WindowEvent e)

  Specified by:
    `windowDeactivated` in interface `java.awt.event.WindowListener`

### windowDeiconified

    public void windowDeiconified(java.awt.event.WindowEvent e)

  Specified by:
    `windowDeiconified` in interface `java.awt.event.WindowListener`

### windowIconified

    public void windowIconified(java.awt.event.WindowEvent e)

  Specified by:
    `windowIconified` in interface `java.awt.event.WindowListener`

### windowOpened

    public void windowOpened(java.awt.event.WindowEvent e)

  Specified by:
    `windowOpened` in interface `java.awt.event.WindowListener`

### register

    public void register(java.lang.Class c)

  Adds the specified class to a Vector to keep it from being garbage collected, causing static fields to be reset.

### quit

    public void quit()

  Called by ImageJ when the user selects Quit.

### quitting

    public boolean quitting()

  Returns true if ImageJ is exiting.

### savePreferences

    public void savePreferences(java.util.Properties prefs)

  Called once when ImageJ quits.

### main

    public static void main(java.lang.String[] args)

### getPort

    public static int getPort()

  Returns the port that ImageJ checks on startup to see if another instance is running.

  See Also:
    `SocketListener`

### getArgs

    public static java.lang.String[] getArgs()

  Returns the command line arguments passed to ImageJ.

### exitWhenQuitting

    public void exitWhenQuitting(boolean ewq)

  ImageJ calls System.exit() when qutting when 'exitWhenQuitting' is true.

### run

    public void run()

  Quit using a separate thread, hopefully avoiding thread deadlocks.

  Specified by:
    `run` in interface `java.lang.Runnable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD